<?php
/*** COPYRIGHT NOTICE *********************************************************
 *
 * Copyright 2009-2017 ProjeQtOr - Pascal BERNARD - support@projeqtor.org
 * Contributors : Eliott LEGRAND (from Salto Consulting - 2018) 
 *
 * This file is part of ProjeQtOr.
 * 
 * ProjeQtOr is free software: you can redistribute it and/or modify it under 
 * the terms of the GNU Affero General Public License as published by the Free 
 * Software Foundation, either version 3 of the License, or (at your option) 
 * any later version.
 * 
 * ProjeQtOr is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE.  See the GNU Affero General Public License for 
 * more details.
 *
 * You should have received a copy of the GNU Affero General Public License along with
 * ProjeQtOr. If not, see <http://www.gnu.org/licenses/>.
 *
 * You can get complete code of ProjeQtOr, other resource, help and information
 * about contributors at http://www.projeqtor.org 
 *     
 *** DO NOT REMOVE THIS NOTICE ************************************************/

// ELIOTT - LEAVE SYSTEM

/** ============================================================================
 * 
 */
require_once "../tool/projeqtor.php";

//return all the leaves of the current user between startDate and enDate passed in REQUEST
if(!isset($_REQUEST['startDate']) and !isset($_REQUEST['endDate'])){//error missing startDate and endDate
    $result= htmlSetResultMessage(null, 
                                  i18n("errorWrongRequest")." ".i18n("missing")." : startDate AND endDate", 
                                  false,
                                  "", 
                                  "GET LEAVES",
                                  "INVALID");

    echo json_encode($result);
    exit;
}

if(!isset($_REQUEST['startDate'])){//error missing startDate
    $result= htmlSetResultMessage(null, 
                                  i18n("errorWrongRequest")." ".i18n("missing")." : startDate", 
                                  false,
                                  "", 
                                  "GET LEAVES",
                                  "INVALID");

    echo json_encode($result);
    exit;
}

if(!isset($_REQUEST['endDate'])){//missing endDate
    $result= htmlSetResultMessage(null, 
                                  i18n("errorWrongRequest")." ".i18n("missing")." : endDate", 
                                  false,
                                  "", 
                                  "GET LEAVES",
                                  "INVALID");

    echo json_encode($result);
    exit;
}

$idRes = null;
if(isset($_REQUEST['idRes'])){
    $idRes = $_REQUEST['idRes'];
} else {
    $idRes = getSessionUser()->id;
}

$lvList=getUserLeaves($_REQUEST['startDate'],$_REQUEST['endDate'], $idRes);

if($lvList==-1){//error in getUserLeaves()
    $result= htmlSetResultMessage(null, 
                                  i18n("EmployeePassedInRequestIsNotAnEmployee"), 
                                  false,
                                  "", 
                                  "GET LEAVES",
                                  "INVALID");

    echo json_encode($result);
    exit;
}

$emp = new Employee($idRes);
if ($emp->id<0 or $emp->idle==1) { // idRes is'nt activ employee
    $result= htmlSetResultMessage(null, 
                                  i18n("EmployeePassedInRequestIsNotAnEmployee"), 
                                  false,
                                  "", 
                                  "GET LEAVES",
                                  "INVALID");

    echo json_encode($result);
    exit;    
}

$leftList = $emp->getLeftLeavesByLeaveType();

$statusList = Workflow::getLeaveMngListStatus();
$resStatus=null;
foreach($statusList as $status) {
    if ($resStatus==null) {
        $resStatus[0] = $status;
    } else {
        array_push($resStatus, $status);
    }
} 

$lvType=new LeaveType();
$resLvTypes=$lvType->getSqlElementsFromCriteria(array());
if(! $lvList){
    $res=array(
        "leaves"=>"empty",
        "leaveTypes"=>$resLvTypes,
        "status"=>$resStatus,
        "left"=>$leftList
    );
    echo json_encode($res);
    exit;
}

$res=array(
    "leaves"=>$lvList,
    "leaveTypes"=>$resLvTypes,
    "status"=>$resStatus,
    "left"=>$leftList
);
echo json_encode($res);
